local Combat = {}
SimplisticUF:RegisterModule(Combat, "combatText", SimplisticUF.L["Combat text"])

function Combat:OnEnable(frame)
	if( not frame.combatText ) then
		frame.combatText = CreateFrame("Frame", nil, frame.highFrame)
		frame.combatText:SetFrameStrata("HIGH")
		frame.combatText.feedbackText = frame.combatText:CreateFontString(nil, "ARTWORK")
		frame.combatText.feedbackText:SetPoint("CENTER", frame.combatText, "CENTER", 0, 0)
		frame.combatText:SetFrameLevel(frame.topFrameLevel)

		frame.combatText.feedbackStartTime = 0
		frame.combatText:SetScript("OnUpdate", CombatFeedback_OnUpdate)
		frame.combatText:SetHeight(1)
		frame.combatText:SetWidth(1)
	end

	frame:RegisterUnitEvent("UNIT_COMBAT", self, "Update")
end

function Combat:OnLayoutApplied(frame, config)
	-- Update feedback text
	SimplisticUF.Layout:ToggleVisibility(frame.combatText, frame.visibility.combatText)
	if( frame.visibility.combatText ) then
		frame.combatText.feedbackFontHeight = SimplisticUF.db.profile.font.size + 1
		frame.combatText.fontPath = SimplisticUF.Layout.mediaPath.font

		SimplisticUF.Layout:SetupFontString(frame.combatText.feedbackText, 1)
		SimplisticUF.Layout:AnchorFrame(frame, frame.combatText, config.combatText)
	end
end

function Combat:OnDisable(frame)
	frame:UnregisterAll(self)
end

function Combat:Update(frame, event, unit, type, ...)
	CombatFeedback_OnCombatEvent(frame.combatText, type, ...)
	if( type == "IMMUNE" ) then
		frame.combatText.feedbackText:SetTextHeight(frame.combatText.feedbackFontHeight * 0.75)
	end

	-- Increasing the font size will make the text look pixelated, however scaling it up will make it look smooth and awesome
	frame.combatText:SetScale(frame.combatText.feedbackText:GetStringHeight() / SimplisticUF.db.profile.font.size)
	frame.combatText.feedbackText:SetFont(frame.combatText.fontPath, SimplisticUF.db.profile.font.size, "OUTLINE")
end
