ECLIPSE_MARKER_COORDS =  {};
ECLIPSE_MARKER_COORDS["none"] 	= { 0.914, 1.0, 0.82, 1.0 };
ECLIPSE_MARKER_COORDS["sun"] 	= { 0.914, 1.0, 0.641, 0.82 };
ECLIPSE_MARKER_COORDS["moon"] 	= { 1.0, 0.914, 0.641, 0.82 };
local EclipseBar = {}
SimplisticUF:RegisterModule(EclipseBar, "eclipseBar", SimplisticUF.L["Eclipse Bar"], true, "DRUID")

function EclipseBar:OnEnable(frame)
	if( not frame.eclipseBar ) then
		frame.eclipseBar = CreateFrame("StatusBar", nil, frame)
		frame.eclipseBar:SetMinMaxValues(0, 1)
		frame.eclipseBar:SetValue(0)
		frame.eclipseBar.bars = {}
		frame.eclipseBar.icon = CreateFrame("Frame", nil, frame.eclipseBar)
		frame.eclipseBar.icon.texture = frame.eclipseBar.icon:CreateTexture()
		frame.eclipseBar.icon.texture:SetTexture([[Interface\PlayerFrame\UI-DruidEclipse]])
		frame.eclipseBar.icon.texture:SetBlendMode("ADD")
		frame.eclipseBar.icon:SetPoint("CENTER", frame.eclipseBar)
		frame.eclipseBar.icon.texture:SetAllPoints(frame.eclipseBar.icon)
		for id=1, 2 do
			local bar = SimplisticUF.Units:CreateBar(frame.eclipseBar)
			bar:SetFrameLevel(1)

			if( id > 1 ) then
				bar:SetPoint("TOPLEFT", frame.eclipseBar.bars[id - 1], "TOPRIGHT", 1, 0)
			else
				bar:SetPoint("TOPLEFT", frame.eclipseBar, "TOPLEFT", 0, 0)
			end

			frame.eclipseBar.bars[id] = bar
		end
	end
	frame:RegisterNormalEvent("UNIT_POWER", self, "Update")
	frame:RegisterNormalEvent("ECLIPSE_DIRECTION_CHANGE", self, "UpdateDirection")
	frame:RegisterNormalEvent("UPDATE_SHAPESHIFT_FORM", self, "UpdateShown")
	frame:RegisterNormalEvent("PLAYER_TALENT_UPDATE", self, "UpdateShown")
	frame:RegisterUpdateFunc(self, "Update")
end

function EclipseBar:OnDisable(frame)
	frame:UnregisterAll(self)
end

function EclipseBar:UpdateShown(frame)
	local form  = GetShapeshiftFormID()
	local spec = GetPrimaryTalentTree()
	SimplisticUF.Layout:SetBarVisibility(frame, "eclipseBar", (form == MOONKIN_FORM or not form and spec == 1))
end

function EclipseBar:UpdateDirection(frame)
	local direction = GetEclipseDirection();
	if direction then
		frame.eclipseBar.icon.texture:SetTexCoord ( unpack(ECLIPSE_MARKER_COORDS[direction]) )
	end
end

function EclipseBar:OnLayoutApplied(frame)
	if( frame.visibility.eclipseBar ) then
		local barWidth = (frame.eclipseBar:GetWidth() - 1) / 2

		for id, bar in pairs(frame.eclipseBar.bars) do
			bar:SetStatusBarTexture(SimplisticUF.Layout.mediaPath.statusbar)
			bar:GetStatusBarTexture():SetHorizTile(false)
			bar:SetHeight(frame.eclipseBar:GetHeight())
			bar:SetWidth(barWidth)
		end
		frame.eclipseBar.icon:SetHeight(frame.eclipseBar:GetHeight()*2)
		frame.eclipseBar.icon:SetWidth(frame.eclipseBar:GetHeight()*2)
		frame.eclipseBar.bars[1]:SetStatusBarColor(0, 0, 1, SimplisticUF.db.profile.bars.alpha)
		frame.eclipseBar.bars[2]:SetStatusBarColor(1, 1, 0, SimplisticUF.db.profile.bars.alpha)
		self:UpdateDirection(frame)
		self:Update(frame, _, _, "ECLIPSE")
		self:UpdateShown(frame)
	end
end

function EclipseBar:Update(frame, event, arg1, id)
	if (id == "ECLIPSE") then
		local power = UnitPower("player", SPELL_POWER_ECLIPSE)
		local xpos = ((frame.eclipseBar:GetWidth()/2)*(power/100))
		frame.eclipseBar.icon:SetPoint("CENTER", frame.eclipseBar, "CENTER", xpos, 0)
	end
end
