local ShardBar = {}
SimplisticUF:RegisterModule(ShardBar, "shardBar", SimplisticUF.L["Soul Shard Bar"], true, "WARLOCK")

function ShardBar:OnEnable(frame)
	if( not frame.shardBar ) then
		frame.shardBar = CreateFrame("StatusBar", nil, frame)
		frame.shardBar:SetMinMaxValues(0, 1)
		frame.shardBar:SetValue(0)
		frame.shardBar.shards = {}

		for id=1, 3 do
			local shard = SimplisticUF.Units:CreateBar(frame.shardBar)
			shard:SetFrameLevel(1)
			shard:SetMinMaxValues(0, 1)
			if( id > 1 ) then
				shard:SetPoint("TOPLEFT", frame.shardBar.shards[id - 1], "TOPRIGHT", 1, 0)
			else
				shard:SetPoint("TOPLEFT", frame.shardBar, "TOPLEFT", 0, 0)
			end

			frame.shardBar.shards[id] = shard
		end
	end
	frame:RegisterNormalEvent("UNIT_POWER", self, "Update")
	frame:RegisterUpdateFunc(self, "Update")
end

function ShardBar:OnDisable(frame)
	frame:UnregisterAll(self)
end

function ShardBar:OnLayoutApplied(frame)
	if( frame.visibility.shardBar ) then
		local barWidth = (frame.shardBar:GetWidth() - 2) / 3

		for id, shard in pairs(frame.shardBar.shards) do
			if( SimplisticUF.db.profile.units[frame.unitType].shardBar.background ) then
				shard.background:Show()
			else
				shard.background:Hide()
			end

			shard.background:SetTexture(SimplisticUF.Layout.mediaPath.statusbar)
			shard.background:SetHorizTile(false)
			shard.background:SetVertexColor(0.58, 0.51, 0.79, SimplisticUF.db.profile.bars.backgroundAlpha)
			shard:SetStatusBarTexture(SimplisticUF.Layout.mediaPath.statusbar)
			shard:GetStatusBarTexture():SetHorizTile(false)
			shard:SetHeight(frame.shardBar:GetHeight())
			shard:SetWidth(barWidth)
			shard:SetStatusBarColor(0.58, 0.51, 0.79, SimplisticUF.db.profile.bars.alpha)
		end
		self:Update(frame, nil, nil, "SOUL_SHARDS")
	end
end

function ShardBar:Update(frame, event, _, id)
	if ( id == "SOUL_SHARDS" ) then
		local power = UnitPower( ShardBarFrame:GetParent().unit, SPELL_POWER_SOUL_SHARDS )
		for id=1, 3 do
			if ( id <= power) then
				frame.shardBar.shards[id]:SetValue(1)
			else
				frame.shardBar.shards[id]:SetValue(0)
			end
		end
	end
end
